## Main Index:

- [Available Commands](#available-commands)
  - [Flows](#flows)
  - [Steps](#steps)
    - [release::start (start one gitFlow branch )](#start-start-one-gitflow-branch)
- [Plugins](#plugins)


## Available Commands:

### STEPS

#### release::start (start one gitFlow branch )
[[Index]](#main-index)


## Description

This step create a new branch on the git Flow methodology. Can be use from a master or develop branch.

## Parameters

- **--targetBranch**: String (hotfix/feature/release) Defined by startBranches parameter

By default:
  **from master** -&gt; only hotfix branches is possible to be created.
  **from develop** -&gt; you have to choose between feature or release branch.

- **--branchName**: String (is necessary to set ${targetBranch}/ first)
- **--jsonFiles**: [Array], default: [&#39;bower.json&#39;, &#39;package.json&#39;] : Sets json files to search in order to be changed, used by **runas-plugin-semver**
- **--startBranches**: [Object], default: (definition of branches that can be started from other branch)

## startBranches - configuration

By default is:

```
  &quot;startBranches&quot;: {
    &quot;develop&quot; : {
      &quot;feature&quot; : {
        &quot;title&quot; : &quot;new feature&quot;
      },
      &quot;release&quot; : {
        &quot;title&quot; : &quot;new release&quot;,
        &quot;originVersionChange&quot; : {
          &quot;major&quot;: [&quot;premajor&quot; , &quot;beta&quot;],
          &quot;minor&quot;: [&quot;preminor&quot; , &quot;beta&quot;],
          &quot;patch&quot;: [&quot;prepatch&quot; , &quot;beta&quot;]
        }
      },
      &quot;merger&quot; : {
        &quot;title&quot; : &quot;new master merger&quot;
      }
    },
    &quot;master&quot; : {
      &quot;hotfix&quot; : {
        &quot;title&quot;: &quot;new hotfix&quot;
      }
    }
  },
```

### Origin branch name (first object level)

By default are &quot;develop&quot;, &quot;master&quot;. If start is execute in any other branch this step fails.

### New target branch type (Second object level)

The branch is going to be started. options: feature, release, merger and hotfix.

- **title:** Is the prompt that will appear when step ask &quot;What do you want to start?&quot;
- **originVersionChange:** (Opcional)[Object] with the choices for the version of the new branch started.

f.i.:     &quot;major&quot;: [&quot;premajor&quot; , &quot;beta&quot;],

&quot;major&quot; -&gt; text prompted in question
[&quot;premajor&quot; , &quot;beta&quot;] -&gt; Version strategy and prereleaseTag

(see runas-plugin-semver for information)

## Stages

### check

git fetch -p &amp; git pull

### run

Create and push new branch
git branch branchName
git checkout branchName
git push -all

## Plugins

- runas-plugin-semver
- runas-plugin-scm-git

## PLUGINS

