
### Description

This step create a new branch on the git Flow methodology. Can be use from a master or develop branch.

### Parameters

- **--targetBranch**: String (hotfix/feature/release) Defined by startBranches parameter

By default:
  **from master** -> only hotfix branches is possible to be created.
  **from develop** -> you have to choose between feature or release branch.

- **--branchName**: String (is necessary to set ${targetBranch}/ first)
- **--jsonFiles**: [Array], default: ['bower.json', 'package.json'] : Sets json files to search in order to be changed, used by **runas-plugin-semver**
- **--startBranches**: [Object], default: (definition of branches that can be started from other branch)

#### startBranches - configuration

By default is:

```
  "startBranches": {
    "develop" : {
      "feature" : {
        "title" : "new feature"
      },
      "release" : {
        "title" : "new release",
        "originVersionChange" : {
          "major": ["premajor" , "beta"],
          "minor": ["preminor" , "beta"],
          "patch": ["prepatch" , "beta"]
        }
      },
      "merger" : {
        "title" : "new master merger"
      }
    },
    "master" : {
      "hotfix" : {
        "title": "new hotfix"
      }
    }
  },
```

##### Origin branch name (first object level)

By default are "develop", "master". If start is execute in any other branch this step fails.

### New target branch type (Second object level)

The branch is going to be started. options: feature, release, merger and hotfix.

- **title:** Is the prompt that will appear when step ask "What do you want to start?"
- **originVersionChange:** (Opcional)[Object] with the choices for the version of the new branch started.

f.i.:     "major": ["premajor" , "beta"],

"major" -> text prompted in question
["premajor" , "beta"] -> Version strategy and prereleaseTag

(see runas-plugin-semver for information)

### Stages

#### check

git fetch -p & git pull

#### run

Create and push new branch
git branch branchName
git checkout branchName
git push -all

### Plugins

- runas-plugin-semver
- runas-plugin-scm-git